<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\UserRequest;
use Exception;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Routing\Redirector;
use Illuminate\View\View;

use App\User;
use App\Module;
use App\RoleModule;
use App\UserDescription;
use App\UserModule;
use App\BranchUser;
use App\Branch;
use App\Role;

class UserController extends Controller
{
    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/users';
    /** View folder */
    private $viewDirectory= 'admin.users.';

    /**
     * Display a listing of the resource.
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('users.head');
        $request= $request->toArray();
        $roles = Role::where('id','!=','6')->get();
        $branches = Branch::cursor();
        return view($this->viewDirectory.'index',compact('title','roles','branches'));
    }

    /**
     * return data of the users.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $query = User::orderBy('id', 'DESC')->where('role_id','!=','6');

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('name', 'LIKE', '%'.$request->name.'%');
        }

        if ($request->email) {
            $query->where('email', 'LIKE', '%'.$request->email.'%');
        }
         if ($request->gender != '') {
            $ids = UserDescription::where('gender',$request->gender)->pluck('user_id');
            $query->whereIn('id', $ids);
        }
        if ($request->date_of_birth != '') {
            $ids = UserDescription::whereMonth('date_of_birth','=',$request->date_of_birth)->pluck('user_id');
            
            $query->whereIn('id', $ids);
        }
        if ($request->branches != '') {
            $ids = BranchUser::where('branch_id',$request->branches)->pluck('user_id');
            
            $query->whereIn('id', $ids);
        }

        if ($request->role) {
            $query->where('role_id', $request->role );
        }

        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $users= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('users'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('users.store');
        $head = metaFields('users', 'add_new', getCurrentLocale()) ?? __('users.new');
        $data = array('4','5','6');
        $roles= Role::whereNotIn('id', $data)->get();
        $branches = Branch::all();
        return view( $this->viewDirectory.'form', compact('action', 'head', 'roles','branches') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param UserRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(UserRequest $request) :RedirectResponse
    {   
        $request->merge(['password'=>bcrypt($request->password)]);
        $user= User::create($request->all());
        $request->merge(['user_id' => $user->id]);
        
        $data = $request->except(['photo','name','email','password','phone','password_confirmation','role_id']);
        
        $details = UserDescription::create($data);
        $user->branches()->attach($request->branches);
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  User  $user
     * @return View
     */
    public function edit(User $user): View
    {
        $action= route('users.update', $user->id);
        $head = metaFields('users', 'edit', getCurrentLocale()) ?? __('users.edit');
        $branches = Branch::all();
        $data = array('4','5','6');
        $roles= Role::whereNotIn('id', $data)->get();
        

        return view( $this->viewDirectory.'form', compact('user', 'action', 'head', 'roles' ,'branches') );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  UserRequest  $request
     * @param  User  $user
     * @return RedirectResponse|Redirector
     */
    public function update(UserRequest $request, User $user) :RedirectResponse
    {
        // dd($request->all());
        $data= $request->all();

        if($data['password']) {
            $data['password']= bcrypt( $data['password'] );
        } else {
            unset($data['password']);
        }
        $user->update($data);
        
        
         $request->merge(['user_id' => $user->id]);
       $old = UserDescription::where('user_id',$user->id)->forceDelete();
        $data = $request->except(['photo','name','email','password','phone','password_confirmation','role_id']);
       
        $details = UserDescription::create($data);
        
        $user->branches()->sync($request->branches);

        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $user = User::withTrashed()->find($id);
        if ($user) {
            if ($user->deleted_at) {
                $user->forceDelete();
            } else {
                $user->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            User::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            User::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $user = User::withTrashed()->find($id);

        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $user = User::whereIn('id', $request->ids)->onlyTrashed();
        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
